/*
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.compdef.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.papyrus.uml.alf.services.CommonGrammarAccess;
import org.eclipse.papyrus.uml.textedit.common.xtext.services.UmlCommonGrammarAccess;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class CompDefGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class ComponentElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Component");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cComponentKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cPortsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cPortsPortParserRuleCall_3_0 = (RuleCall)cPortsAssignment_3.eContents().get(0);
		private final Assignment cActivityAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cActivityActivityParserRuleCall_4_0 = (RuleCall)cActivityAssignment_4.eContents().get(0);
		private final Assignment cParametersAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cParametersParameterParserRuleCall_5_0 = (RuleCall)cParametersAssignment_5.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		
		//Component:
		//    'component' name = ID '{'
		//        (ports += Port)*
		//        (activity += Activity)*
		//        (parameters += Parameter)*
		//    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'component' name = ID '{'
		//    (ports += Port)*
		//    (activity += Activity)*
		//    (parameters += Parameter)*
		//'}'
		public Group getGroup() { return cGroup; }
		
		//'component'
		public Keyword getComponentKeyword_0() { return cComponentKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//(ports += Port)*
		public Assignment getPortsAssignment_3() { return cPortsAssignment_3; }
		
		//Port
		public RuleCall getPortsPortParserRuleCall_3_0() { return cPortsPortParserRuleCall_3_0; }
		
		//(activity += Activity)*
		public Assignment getActivityAssignment_4() { return cActivityAssignment_4; }
		
		//Activity
		public RuleCall getActivityActivityParserRuleCall_4_0() { return cActivityActivityParserRuleCall_4_0; }
		
		//(parameters += Parameter)*
		public Assignment getParametersAssignment_5() { return cParametersAssignment_5; }
		
		//Parameter
		public RuleCall getParametersParameterParserRuleCall_5_0() { return cParametersParameterParserRuleCall_5_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
	}
	public class ParameterElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Parameter");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cParameterKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cColonKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Alternatives cAlternatives_2_1 = (Alternatives)cGroup_2.eContents().get(1);
		private final Assignment cTypeAssignment_2_1_0 = (Assignment)cAlternatives_2_1.eContents().get(0);
		private final RuleCall cTypeTypeRuleParserRuleCall_2_1_0_0 = (RuleCall)cTypeAssignment_2_1_0.eContents().get(0);
		private final Assignment cTypeUndefinedAssignment_2_1_1 = (Assignment)cAlternatives_2_1.eContents().get(1);
		private final Keyword cTypeUndefinedUndefinedKeyword_2_1_1_0 = (Keyword)cTypeUndefinedAssignment_2_1_1.eContents().get(0);
		private final Assignment cMultiplicityAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cMultiplicityMultiplicityRuleParserRuleCall_3_0 = (RuleCall)cMultiplicityAssignment_3.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cEqualsSignKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cValueAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cValueValueParserRuleCall_4_1_0 = (RuleCall)cValueAssignment_4_1.eContents().get(0);
		private final Assignment cCommentAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cCommentVSL_COMMENTTerminalRuleCall_5_0 = (RuleCall)cCommentAssignment_5.eContents().get(0);
		
		//Parameter:
		//    'parameter' name = ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		//    (multiplicity = MultiplicityRule)?
		//    ('=' value = Value)?
		//    (comment = VSL_COMMENT)?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'parameter' name = ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		//(multiplicity = MultiplicityRule)?
		//('=' value = Value)?
		//(comment = VSL_COMMENT)?
		public Group getGroup() { return cGroup; }
		
		//'parameter'
		public Keyword getParameterKeyword_0() { return cParameterKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//(':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		public Group getGroup_2() { return cGroup_2; }
		
		//':'
		public Keyword getColonKeyword_2_0() { return cColonKeyword_2_0; }
		
		//(type=TypeRule | typeUndefined?="<Undefined>")
		public Alternatives getAlternatives_2_1() { return cAlternatives_2_1; }
		
		//type=TypeRule
		public Assignment getTypeAssignment_2_1_0() { return cTypeAssignment_2_1_0; }
		
		//TypeRule
		public RuleCall getTypeTypeRuleParserRuleCall_2_1_0_0() { return cTypeTypeRuleParserRuleCall_2_1_0_0; }
		
		//typeUndefined?="<Undefined>"
		public Assignment getTypeUndefinedAssignment_2_1_1() { return cTypeUndefinedAssignment_2_1_1; }
		
		//"<Undefined>"
		public Keyword getTypeUndefinedUndefinedKeyword_2_1_1_0() { return cTypeUndefinedUndefinedKeyword_2_1_1_0; }
		
		//(multiplicity = MultiplicityRule)?
		public Assignment getMultiplicityAssignment_3() { return cMultiplicityAssignment_3; }
		
		//MultiplicityRule
		public RuleCall getMultiplicityMultiplicityRuleParserRuleCall_3_0() { return cMultiplicityMultiplicityRuleParserRuleCall_3_0; }
		
		//('=' value = Value)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'='
		public Keyword getEqualsSignKeyword_4_0() { return cEqualsSignKeyword_4_0; }
		
		//value = Value
		public Assignment getValueAssignment_4_1() { return cValueAssignment_4_1; }
		
		//Value
		public RuleCall getValueValueParserRuleCall_4_1_0() { return cValueValueParserRuleCall_4_1_0; }
		
		//(comment = VSL_COMMENT)?
		public Assignment getCommentAssignment_5() { return cCommentAssignment_5; }
		
		//VSL_COMMENT
		public RuleCall getCommentVSL_COMMENTTerminalRuleCall_5_0() { return cCommentVSL_COMMENTTerminalRuleCall_5_0; }
	}
	public class ValueElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Value");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Assignment cStrAssignment_0 = (Assignment)cAlternatives.eContents().get(0);
		private final RuleCall cStrSTRINGTerminalRuleCall_0_0 = (RuleCall)cStrAssignment_0.eContents().get(0);
		private final Assignment cIvalAssignment_1 = (Assignment)cAlternatives.eContents().get(1);
		private final RuleCall cIvalINTTerminalRuleCall_1_0 = (RuleCall)cIvalAssignment_1.eContents().get(0);
		private final Assignment cDvalAssignment_2 = (Assignment)cAlternatives.eContents().get(2);
		private final RuleCall cDvalDOUBLETerminalRuleCall_2_0 = (RuleCall)cDvalAssignment_2.eContents().get(0);
		
		//Value:
		//    (str = STRING) |
		//    (ival = INT) |
		//    (dval = DOUBLE)
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//(str = STRING) |
		//(ival = INT) |
		//(dval = DOUBLE)
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//(str = STRING)
		public Assignment getStrAssignment_0() { return cStrAssignment_0; }
		
		//STRING
		public RuleCall getStrSTRINGTerminalRuleCall_0_0() { return cStrSTRINGTerminalRuleCall_0_0; }
		
		//(ival = INT)
		public Assignment getIvalAssignment_1() { return cIvalAssignment_1; }
		
		//INT
		public RuleCall getIvalINTTerminalRuleCall_1_0() { return cIvalINTTerminalRuleCall_1_0; }
		
		//(dval = DOUBLE)
		public Assignment getDvalAssignment_2() { return cDvalAssignment_2; }
		
		//DOUBLE
		public RuleCall getDvalDOUBLETerminalRuleCall_2_0() { return cDvalDOUBLETerminalRuleCall_2_0; }
	}
	public class PortElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Port");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cPortKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cProvidesKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Assignment cProvAssignment_2_1 = (Assignment)cGroup_2.eContents().get(1);
		private final RuleCall cProvTypeRuleParserRuleCall_2_1_0 = (RuleCall)cProvAssignment_2_1.eContents().get(0);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cRequiresKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cReqAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cReqTypeRuleParserRuleCall_3_1_0 = (RuleCall)cReqAssignment_3_1.eContents().get(0);
		
		//Port:
		//    'port' name = ID
		//    ('provides' (prov = TypeRule)) ?
		//    ('requires' (req = TypeRule)) ?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'port' name = ID
		//('provides' (prov = TypeRule)) ?
		//('requires' (req = TypeRule)) ?
		public Group getGroup() { return cGroup; }
		
		//'port'
		public Keyword getPortKeyword_0() { return cPortKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//('provides' (prov = TypeRule)) ?
		public Group getGroup_2() { return cGroup_2; }
		
		//'provides'
		public Keyword getProvidesKeyword_2_0() { return cProvidesKeyword_2_0; }
		
		//(prov = TypeRule)
		public Assignment getProvAssignment_2_1() { return cProvAssignment_2_1; }
		
		//TypeRule
		public RuleCall getProvTypeRuleParserRuleCall_2_1_0() { return cProvTypeRuleParserRuleCall_2_1_0; }
		
		//('requires' (req = TypeRule)) ?
		public Group getGroup_3() { return cGroup_3; }
		
		//'requires'
		public Keyword getRequiresKeyword_3_0() { return cRequiresKeyword_3_0; }
		
		//(req = TypeRule)
		public Assignment getReqAssignment_3_1() { return cReqAssignment_3_1; }
		
		//TypeRule
		public RuleCall getReqTypeRuleParserRuleCall_3_1_0() { return cReqTypeRuleParserRuleCall_3_1_0; }
	}
	public class ActivityElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Activity");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cActivityKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		
		//Activity:
		//    'activity' name = ID
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'activity' name = ID
		public Group getGroup() { return cGroup; }
		
		//'activity'
		public Keyword getActivityKeyword_0() { return cActivityKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
	}
	public class ConnectorElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.Connector");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cConnectorKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cConnectsKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cEndAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cEndConnectorEndParserRuleCall_3_0 = (RuleCall)cEndAssignment_3.eContents().get(0);
		
		//Connector:
		//    'connector' name = ID
		//    // list of ports
		//    'connects' (end += ConnectorEnd)*
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'connector' name = ID
		//// list of ports
		//'connects' (end += ConnectorEnd)*
		public Group getGroup() { return cGroup; }
		
		//'connector'
		public Keyword getConnectorKeyword_0() { return cConnectorKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//// list of ports
		//'connects'
		public Keyword getConnectsKeyword_2() { return cConnectsKeyword_2; }
		
		//(end += ConnectorEnd)*
		public Assignment getEndAssignment_3() { return cEndAssignment_3; }
		
		//ConnectorEnd
		public RuleCall getEndConnectorEndParserRuleCall_3_0() { return cEndConnectorEndParserRuleCall_3_0; }
	}
	public class ConnectorEndElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.ConnectorEnd");
		private final Assignment cPortAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cPortIDTerminalRuleCall_0 = (RuleCall)cPortAssignment.eContents().get(0);
		
		//ConnectorEnd:
		//    port = ID
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//port = ID
		public Assignment getPortAssignment() { return cPortAssignment; }
		
		//ID
		public RuleCall getPortIDTerminalRuleCall_0() { return cPortIDTerminalRuleCall_0; }
	}
	
	
	private final ComponentElements pComponent;
	private final TerminalRule tVSL_COMMENT;
	private final ParameterElements pParameter;
	private final ValueElements pValue;
	private final TerminalRule tDOUBLE;
	private final PortElements pPort;
	private final ActivityElements pActivity;
	private final ConnectorElements pConnector;
	private final ConnectorEndElements pConnectorEnd;
	
	private final Grammar grammar;
	
	private final UmlCommonGrammarAccess gaUmlCommon;
	
	private final CommonGrammarAccess gaCommon;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public CompDefGrammarAccess(GrammarProvider grammarProvider,
			UmlCommonGrammarAccess gaUmlCommon,
			CommonGrammarAccess gaCommon,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaUmlCommon = gaUmlCommon;
		this.gaCommon = gaCommon;
		this.gaTerminals = gaTerminals;
		this.pComponent = new ComponentElements();
		this.tVSL_COMMENT = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.VSL_COMMENT");
		this.pParameter = new ParameterElements();
		this.pValue = new ValueElements();
		this.tDOUBLE = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.compdef.CompDef.DOUBLE");
		this.pPort = new PortElements();
		this.pActivity = new ActivityElements();
		this.pConnector = new ConnectorElements();
		this.pConnectorEnd = new ConnectorEndElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.eclipse.papyrus.robotics.xtext.compdef.CompDef".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public UmlCommonGrammarAccess getUmlCommonGrammarAccess() {
		return gaUmlCommon;
	}
	
	public CommonGrammarAccess getCommonGrammarAccess() {
		return gaCommon;
	}
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Component:
	//    'component' name = ID '{'
	//        (ports += Port)*
	//        (activity += Activity)*
	//        (parameters += Parameter)*
	//    '}'
	//;
	public ComponentElements getComponentAccess() {
		return pComponent;
	}
	
	public ParserRule getComponentRule() {
		return getComponentAccess().getRule();
	}
	
	//// visible copy of the SL comment (documentation not clear about how to access comments)
	//terminal VSL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getVSL_COMMENTRule() {
		return tVSL_COMMENT;
	}
	
	//Parameter:
	//    'parameter' name = ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
	//    (multiplicity = MultiplicityRule)?
	//    ('=' value = Value)?
	//    (comment = VSL_COMMENT)?
	//;
	public ParameterElements getParameterAccess() {
		return pParameter;
	}
	
	public ParserRule getParameterRule() {
		return getParameterAccess().getRule();
	}
	
	//Value:
	//    (str = STRING) |
	//    (ival = INT) |
	//    (dval = DOUBLE)
	//;
	public ValueElements getValueAccess() {
		return pValue;
	}
	
	public ParserRule getValueRule() {
		return getValueAccess().getRule();
	}
	
	//terminal DOUBLE returns ecore::EDouble:
	//    ('0'..'9')+ '.' ('0'..'9')+
	//;
	public TerminalRule getDOUBLERule() {
		return tDOUBLE;
	}
	
	//Port:
	//    'port' name = ID
	//    ('provides' (prov = TypeRule)) ?
	//    ('requires' (req = TypeRule)) ?
	//;
	public PortElements getPortAccess() {
		return pPort;
	}
	
	public ParserRule getPortRule() {
		return getPortAccess().getRule();
	}
	
	//Activity:
	//    'activity' name = ID
	//;
	public ActivityElements getActivityAccess() {
		return pActivity;
	}
	
	public ParserRule getActivityRule() {
		return getActivityAccess().getRule();
	}
	
	//Connector:
	//    'connector' name = ID
	//    // list of ports
	//    'connects' (end += ConnectorEnd)*
	//;
	public ConnectorElements getConnectorAccess() {
		return pConnector;
	}
	
	public ParserRule getConnectorRule() {
		return getConnectorAccess().getRule();
	}
	
	//ConnectorEnd:
	//    port = ID
	//;
	public ConnectorEndElements getConnectorEndAccess() {
		return pConnectorEnd;
	}
	
	public ParserRule getConnectorEndRule() {
		return getConnectorEndAccess().getRule();
	}
	
	//QualifiedName :
	//    path=[uml::Namespace]'::' (remaining=QualifiedName)? ;
	public UmlCommonGrammarAccess.QualifiedNameElements getQualifiedNameAccess() {
		return gaUmlCommon.getQualifiedNameAccess();
	}
	
	public ParserRule getQualifiedNameRule() {
		return getQualifiedNameAccess().getRule();
	}
	
	//TypeRule :
	//    (path=QualifiedName)? type=[uml::Type] ;
	public UmlCommonGrammarAccess.TypeRuleElements getTypeRuleAccess() {
		return gaUmlCommon.getTypeRuleAccess();
	}
	
	public ParserRule getTypeRuleRule() {
		return getTypeRuleAccess().getRule();
	}
	
	//enum VisibilityKind:
	//    public = "+"
	//    | private = "-"
	//    | protected = "#"
	//    | package = "~" ;
	public UmlCommonGrammarAccess.VisibilityKindElements getVisibilityKindAccess() {
		return gaUmlCommon.getVisibilityKindAccess();
	}
	
	public EnumRule getVisibilityKindRule() {
		return getVisibilityKindAccess().getRule();
	}
	
	//MultiplicityRule:
	//    "[" bounds+=BoundSpecification ('..' bounds+=BoundSpecification)? "]" ;
	public UmlCommonGrammarAccess.MultiplicityRuleElements getMultiplicityRuleAccess() {
		return gaUmlCommon.getMultiplicityRuleAccess();
	}
	
	public ParserRule getMultiplicityRuleRule() {
		return getMultiplicityRuleAccess().getRule();
	}
	
	//BoundSpecification:
	//    value = UnlimitedLiteral ;
	public UmlCommonGrammarAccess.BoundSpecificationElements getBoundSpecificationAccess() {
		return gaUmlCommon.getBoundSpecificationAccess();
	}
	
	public ParserRule getBoundSpecificationRule() {
		return getBoundSpecificationAccess().getRule();
	}
	
	//UnlimitedLiteral returns ecore::EString: INT | "*" ;
	public UmlCommonGrammarAccess.UnlimitedLiteralElements getUnlimitedLiteralAccess() {
		return gaUmlCommon.getUnlimitedLiteralAccess();
	}
	
	public ParserRule getUnlimitedLiteralRule() {
		return getUnlimitedLiteralAccess().getRule();
	}
	
	//enum Direction:
	//    IN= "in"
	//    |OUT = "out"
	//    |INOUT = "inout"
	//    |RETURN = "return";
	public UmlCommonGrammarAccess.DirectionElements getDirectionAccess() {
		return gaUmlCommon.getDirectionAccess();
	}
	
	public EnumRule getDirectionRule() {
		return getDirectionAccess().getRule();
	}
	
	//terminal ID : ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*  | ('\'' -> '\'')  ;
	public TerminalRule getIDRule() {
		return gaCommon.getIDRule();
	}
	
	//terminal STRING	: '"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'"'|"'"|'\\') | !('\\'|'"') )* '"' ;
	public TerminalRule getSTRINGRule() {
		return gaCommon.getSTRINGRule();
	}
	
	//terminal ML_COMMENT	: '/*' !('@') -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaCommon.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r'|'@')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaCommon.getSL_COMMENTRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaCommon.getINTRule();
	}
	
	//terminal INTEGER_VALUE :
	//    ('0' | '1'..'9' (('_')? '0'..'9')*) | //DECIMAL
	//    (('0b' | '0B') '0'..'1' (('_')? '0'..'1')*) | // BINARY
	//    (('0x'|'0X') ('0'..'9'|'a'..'f'|'A'..'F')  (('_')? ('0'..'9'|'a'..'f'|'A'..'F'))*) | // HEX
	//    ('0' ('_')? '0'..'7' (('_')? '0'..'7')*) // OCT
	//;
	public TerminalRule getINTEGER_VALUERule() {
		return gaCommon.getINTEGER_VALUERule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
